/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.ProdMercado;
import com.rjconsultores.ventaboletos.entidad.ProductoServicio;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.ProdMercadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Administrador
 */
@Controller("editarProdMercadoController")
@Scope("prototype")
public class EditarProdMercadoController extends MyGenericForwardComposer {

    @Autowired
    private ProdMercadoService prodMercadoService;
    @Autowired
    private ParadaService paradaService;
    private ProductoServicio productoServicio;
    private MyListbox prodMercadoList;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private List<ProdMercado> lsProdMercado;
    private ProdMercado prodMercado;
    private static Logger log = Logger.getLogger(EditarProdMercadoController.class);

    public ProdMercado getProdMercado() {
        return prodMercado;
    }

    public void setProdMercado(ProdMercado prodMercado) {
        this.prodMercado = prodMercado;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        prodMercado = (ProdMercado) Executions.getCurrent().getArg().get("prodMercado");
        productoServicio = (ProductoServicio) Executions.getCurrent().getArg().get("productoServicio");
        prodMercadoList = (MyListbox) Executions.getCurrent().getArg().get("prodMercadoList");
        lsProdMercado = (List<ProdMercado>) Executions.getCurrent().getArg().get("lsProdMercado");

        super.doAfterCompose(comp);

        if (prodMercado.getProdmercadoId() != null) {
            Parada origem = prodMercado.getParada1();
            if (origem != null) {
                cmbOrigem.setText(origem.getDescparada());
            }

            Parada destino = prodMercado.getParada();
            if (destino != null) {
                cmbDestino.setText(destino.getDescparada());
            }
        }
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {

        cmbOrigem.getValue();
        cmbDestino.getValue();

        try {
            if (prodMercado == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarProdMercadoController.winEditarProdMercado.title"),
                        Messagebox.OK, Messagebox.ERROR);
                return;
            }
            if (prodMercado.getProdmercadoId() != null) {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdMercadoController.winEditarProdMercado.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodMercadoService.actualizacion(prodMercado);
                prodMercadoList.updateItem(prodMercado);
                lsProdMercado.add(prodMercado);
            } else {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdMercadoController.winEditarProdMercado.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }

                prodMercado.setProductoServicio(productoServicio);
                prodMercadoService.suscribir(prodMercado);
                prodMercadoList.addItem(prodMercado);
                lsProdMercado.add(prodMercado);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    private boolean registroDuplicado() throws InterruptedException {
        for (ProdMercado p : lsProdMercado) {
            if (!p.getActivo()){
                continue;
            }
            if (p.getParada().getDescparada().equals(prodMercado.getParada().getDescparada())
                    && p.getParada1().getDescparada().equals(prodMercado.getParada1().getDescparada())) {
                return true;
            }
        }
        return false;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdMercadoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdMercadoController.winEditarProdMercado.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodMercado.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodMercado.setFecmodif(Calendar.getInstance().getTime());
                prodMercado.setActivo(Boolean.FALSE);

                prodMercadoList.removeItem(prodMercado);
                prodMercadoService.borrar(prodMercado);

                Messagebox.show(
                        Labels.getLabel("editarProdMercadoController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdMercadoController.winEditarProdMercado.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    /**
     * @return the lsProdMercado
     */
    public List<ProdMercado> getLsProdMercado() {
        return lsProdMercado;
    }

    /**
     * @param lsProdMercado the lsProdMercado to set
     */
    public void setLsProdMercado(List<ProdMercado> lsProdMercado) {
        this.lsProdMercado = lsProdMercado;
    }
}
